patch.sh 4.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157
  1. #!/usr/bin/env bash
  2. # Templates for next patch
  3. #echo " === !! UNTESTED PATCH. CHECK FOR BANS USING A TRASH ACCOUNT !! ==="
  4. #echo " === AND REPORT RESULTS TO THE MAIN REPOSITORY. THANK YOU ==="
  5. #echo "If you would like to test this patch, modify this script and remove the line below this one."
  6. #exit 1
  7. #echo " === !! This patch is very new but almost identical to 1.5.1!! ==="
  8. #echo " === If you are worried, use a secondary account for a few days ==="
  9. #read -p "Continue? [Enter] " _dumpster_
  10. # MacOS and *BSD do not have md5sum: use md5 instead
  11. if [[ $(uname) == "Darwin" || $(uname) == *"BSD" ]]; then
  12. md5sum() {
  13. md5 -q $@
  14. }
  15. fi
  16. DIR=$(dirname "${BASH_SOURCE[0]}")
  17. FILE="UnityPlayer.dll"
  18. CEXE="GenshinImpact_Data/upload_crash.exe"
  19. sum=($(md5sum $FILE))
  20. if [ "${sum}" != "dbc22b32f297b0e75f658dc10e30969d" ]; then # original
  21. # The patch might corrupt invalid/outdated files if this check is skippd.
  22. echo "[ERROR] Wrong file version or the patch is already applied"
  23. echo " -> md5sum: ${sum}" && exit 1
  24. fi
  25. # =========== DO NOT REMOVE START ===========
  26. if [[ -e "$DIR/$FILE" ]]; then
  27. # There is a good reason for this check. Do not pollute the game directory.
  28. echo "[ERROR] Invalid patch download directory. Please move all"
  29. echo " patch files outside the game directory prior executing."
  30. echo " -> See README.md for proper installation instructions" && exit 1
  31. fi
  32. # =========== DO NOT REMOVE END ===========
  33. if ! command -v xdelta3 &>/dev/null; then
  34. echo "[ERROR] xdelta3 application is required"
  35. echo " -> Debian/Ubuntu: apt install xdelta3"
  36. echo " -> Fedora: dnf install xdelta"
  37. echo " -> Arch/Arch-based: pacman -S xdelta3"
  38. echo " -> macOS: \"port install xdelta\" or \"brew install xdelta\""
  39. exit 1
  40. fi
  41. # ===========================================================
  42. echo "[WARNING] Hereby you are violating the game's Terms of Service!"
  43. echo " Do you accept the risk and possible consequences?"
  44. read -p "Accept? [y/n] " choice
  45. if [[ ! "$choice" == [JjSsYy]* ]]; then
  46. exit 1
  47. fi
  48. echo
  49. echo "--- Setting up blocked servers"
  50. # START OF SUDO DANGER ZONE
  51. etc_hosts="$(cat /etc/hosts)"
  52. # See dev_tools/network.md (up-to-date as of 2.1.0)
  53. servers=$(cat <<EOF
  54. # Genshin logging servers (do not remove!)
  55. 0.0.0.0 log-upload-os.mihoyo.com
  56. 0.0.0.0 overseauspider.yuanshen.com
  57. EOF
  58. )
  59. if [[ ! "$etc_hosts" == *"$servers"* ]]; then
  60. echo "[MANDATORY] Adding following logging servers to /etc/hosts"
  61. echo " If you really really want to skip this (Ctrl+C),"
  62. echo " PLEASE add the entries manually. Otherwise they will receive"
  63. echo " logs about The Wine project, hence UNCOVERING THIS PATCH!"
  64. echo "$servers" | sudo -k tee -a /etc/hosts
  65. if [ $? -ne 0 ]; then
  66. echo "$servers"
  67. read -p "Please append these lines to your /etc/hosts file now. Enter to continue."
  68. fi
  69. else
  70. echo "--- Logging servers are already blocked. Skip."
  71. fi
  72. servers=$(cat <<EOF
  73. # Optional Unity proxy/cdn servers
  74. 0.0.0.0 prd-lender.cdp.internal.unity3d.com
  75. 0.0.0.0 thind-prd-knob.data.ie.unity3d.com
  76. 0.0.0.0 thind-gke-usc.prd.data.corp.unity3d.com
  77. 0.0.0.0 cdp.cloud.unity3d.com
  78. 0.0.0.0 remote-config-proxy-prd.uca.cloud.unity3d.com
  79. EOF
  80. )
  81. if [[ ! "$etc_hosts" == *"$servers"* ]]; then
  82. echo ""
  83. echo "[Optional] Adding common Unity proxy/cdn servers to /etc/hosts"
  84. echo " Normally this does not cause any issues. If issues arise in other games,"
  85. echo " consider commenting a few lines to check what makes the difference."
  86. read -p "Add 5 servers? [y/n] " choice
  87. if [[ "$choice" == [JjSsYy]* ]]; then
  88. echo "-- Adding proxy/cdn servers"
  89. echo "$servers" | sudo tee -a /etc/hosts
  90. if [ $? -ne 0 ]; then
  91. read -p "--- FAILED to add the servers. Enter to continue."
  92. fi
  93. fi
  94. else
  95. echo "--- Unity proxy/cdn servers are already blocked. Skip."
  96. fi
  97. etc_hosts=""
  98. # END OF SUDO DANGER ZONE
  99. echo ""
  100. # No crashes shall be reported!
  101. echo "--- Renaming the crash reporter"
  102. if [[ -e "$CEXE" ]]; then
  103. # Replace existing backups
  104. mv -f "$CEXE" "$CEXE.bak"
  105. fi
  106. # Registry entry to add on startup
  107. cp -f "$DIR/patch_files/mhyprot2_running.reg" .
  108. # Add launcher & force update to ensure the checks are performed
  109. echo "--- Adding launcher script"
  110. cp -f "$DIR/patch_files/launcher.bat" .
  111. # Do the patch now, replace existing backups (hash confirmed)
  112. echo "--- Patching UnityPlayer"
  113. xdelta_fail() {
  114. mv -vf "$FILE.bak" "$FILE"
  115. exit 1
  116. }
  117. mv -f "$FILE" "$FILE.bak"
  118. # Perform patch or restore .bak on failure
  119. xdelta3 -d -s "$FILE.bak" "$DIR/patch_files/unityplayer_patch.vcdiff" "$FILE" || xdelta_fail
  120. # Done!
  121. echo "==> Patch applied! Enjoy the game."
  122. echo
  123. echo "[NOTICE] Please refrain from sharing this project in public so"
  124. echo " that there can be Linux patches in the future. Thank you."
  125. exit 0